%define _default_patch_fuzz 2 

Name:           perl-DBIx-Class
Version:        0.08012
Release:        3%{?dist}
Summary:        Extensible and flexible object <-> relational mapper
License:        GPL+ or Artistic
Group:          Development/Libraries
URL:            http://search.cpan.org/dist/DBIx-Class/
Source0:        http://www.cpan.org/authors/id/R/RI/RIBASUSHI/DBIx-Class-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch
Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

## patches...
# make tests skip a little more verbosely
Patch3:         verbose.patch

# core
BuildRequires:  perl >= 1:5.6.1
BuildRequires:  perl(ExtUtils::MakeMaker) 
BuildRequires:  perl(Scalar::Util) 
BuildRequires:  perl(Storable) 
BuildRequires:  perl(Test::Builder) >= 0.32
BuildRequires:  perl(Test::Deep)

## Dependencies
BuildRequires:  perl(Carp::Clan) 
BuildRequires:  perl(Class::Accessor::Grouped) >= 0.08002
BuildRequires:  perl(Class::C3) >= 0.2
BuildRequires:  perl(Class::C3::Componentised) 
# for CDBI-compat bits...
BuildRequires:  perl(Class::Data::Inheritable)
BuildRequires:  perl(Class::Inspector) 
BuildRequires:  perl(Class::Trigger) 
BuildRequires:  perl(Data::Page) >= 2
# see BZ#245699 -- requires patched version, not CPAN
BuildRequires:  perl(DBD::SQLite) >= 1.13
BuildRequires:  perl(DBI) >= 1.4
BuildRequires:  perl(DBIx::ContextualFetch) 
BuildRequires:  perl(JSON::Any) >= 1.17 
BuildRequires:  perl(List::Util) >= 1.19
BuildRequires:  perl(Module::Find)
BuildRequires:  perl(Scope::Guard) >= 0.03
BuildRequires:  perl(SQL::Abstract) >= 1.24
# darn RPM version compares...
#BuildRequires:  perl(SQL::Abstract::Limit) >= 0.13
BuildRequires:  perl(SQL::Abstract::Limit) >= 0.13
BuildRequires:  perl(Test::Exception)
# optional tests
BuildRequires:  perl(DateTime::Format::MySQL)
BuildRequires:  perl(Text::CSV_XS)
BuildRequires:  perl(Test::Memory::Cycle)
BuildRequires:  perl(Test::Pod)
BuildRequires:  perl(Test::Pod::Coverage)
BuildRequires:  perl(SQL::Translator)
BuildRequires:  perl(DateTime)
BuildRequires:  perl(DateTime::Format::Oracle)
BuildRequires:  perl(DBIx::ContextualFetch)


# not picked up...
Requires:       perl(Class::Accessor::Grouped) >= 0.05002
Requires:       perl(Class::C3::Componentised)
Requires:       perl(SQL::Abstract) >= 1.2

# not picked up automagically (yet)... 
Provides:       perl(DBIx::Class::ClassResolver::PassThrough) = 0
Provides:       perl(DBIx::Class::Storage::TxnScopeGuard)     = 0

%description
This is an SQL to OO mapper with an object API inspired by Class::DBI
(and a compatibility layer as a springboard for porting) and a
resultset API that allows abstract encapsulation of database
operations. It aims to make representing queries in your code as perl-
ish as possible while still providing access to as many of the
capabilities of the database as possible, including retrieving related
records from multiple tables in a single query, JOIN, LEFT JOIN, COUNT,
DISTINCT, GROUP BY and HAVING support.

%prep
%setup -q -n DBIx-Class-%{version}

# tell us why we're skipping, eh?
%patch3

find t/ -type f -exec perl -pi -e 's|\r||; s|^#!perl|#!/usr/bin/perl|' {} +
find .  -type f -exec chmod -c -x {} +
find t/ -type f -name '*.orig' -exec rm -v {} +

# utf8 issues
BAD='README ./lib/DBIx/Class/Storage/DBI/Replication.pm ./lib/DBIx/Class.pm'
for i in $BAD ; do 
    iconv -f iso8859-1 -t UTF-8 $i > foo
    mv foo $i 
done

# Filter unwanted Provides:
cat << \EOF > %{name}-prov
#!/bin/sh
%{__perl_provides} `perl -p -e 's|\S+%{_docdir}/%{name}-%{version}\S+||'` 
EOF

%define __perl_provides %{_builddir}/DBIx-Class-%{version}/%{name}-prov
chmod +x %{__perl_provides}

# Filter unwanted Requires:
cat << \EOF > %{name}-req
#!/bin/sh
%{__perl_requires} `perl -p -e 's|\S+%{_docdir}/%{name}-%{version}\S+||'` |\
    sed -e '/perl(DBD::Pg)/d' 
EOF

%define __perl_requires %{_builddir}/DBIx-Class-%{version}/%{name}-req
chmod +x %{__perl_requires}

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}

make pure_install PERL_INSTALL_ROOT=%{buildroot}

find %{buildroot} -type f -name .packlist -exec rm -f {} + 
find %{buildroot} -depth -type d -exec rmdir {} 2>/dev/null \;

%{_fixperms} %{buildroot}/*

%check
# note this test suite is noisy!
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README t/
%{perl_vendorlib}/*
%{_bindir}/*
%{_mandir}/man[13]/*


%changelog
* Sun Mar 22 2009 Robert Scheck <robert@fedoraproject.org> 0.08012-3
- Added missing build requirement perl(Test::Deep) for make tests
- Re-diffed make tests patch for more verbosity when skipping tests

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.08012-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sun Feb 22 2009 Chris Weyl <cweyl@alumni.drew.edu> 0.08012-1
- update to 0.08012

* Thu Oct 16 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-9
- stop filtering perl(DBD::Multi) 

* Sun Oct 05 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-8
- filter all prov/req from anything under _docdir
- note we still filter perl(DBD::Multi), at least until review bug bz#465690
  is completed...
- ...and perl(DBD::Pg) will always be filtered

* Wed Oct 01 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-7
- fix patch fuzz

* Mon Jun 02 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-6
- bump

* Wed Apr 09 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-5
- pod coverage testing NOT enabled; test currently "fails"
- make tests skip a little more verbosely...
- add a br of Class::Data::Inheritable for the CDBI-compat testing

* Tue Apr 01 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-4
- drop unneeded patch1
- set explicit provides version to 0 :)

* Wed Mar 19 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-3
- add perl(Test::Exception) as a br
- revert patches to skip on DBD::SQLite < 1.13

* Tue Mar 18 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-2
- BR JSON -> JSON::Any
- rework sqlite/tests patch to skip on DBD::SQLite < 1.15...  1.14 is in
  rawhide/f9, and frankly, doesn't quite pass muster *sigh*

* Sun Mar 09 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-1
- update to 0.08010

* Wed Jan 16 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08008-3
- add additional BR's for optional tests

* Fri Jan 11 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08008-2
- patch to work around certain tests as DBD::SQLite isn't going to 1.13
  anytime soon (see RH#245699)

* Tue Dec 04 2007 Chris Weyl <cweyl@alumni.drew.edu> 0.08008-1
- update to 0.08008
- correct provides filtering...

* Tue Sep 18 2007 Chris Weyl <cweyl@alumni.drew.edu> 0.08007-1
- Specfile autogenerated by cpanspec 1.71.
